public class Matrix {
    private int x;
    private int y;
    private double[][] data;

    public int getX() {
        return x;
    }

    public void setX(int x) {
        this.x = x;
    }

    public int getY() {
        return y;
    }

    public void setY(int y) {
        this.y = y;
    }

    public double getData(int x, int y) {
        return data[x][y];
    }

    public double[][] getDatas() {
        return data;
    }

    public void setData(int x, int y, double d) {
        this.data[x][y] = d;
    }

    public Matrix(int x, int y) {
        this.x = x;
        this.y = y;
        this.data = new double[x][y];
    }

    public void matrixFill(int x, int y, double[][] tab) throws IndexOutOfBoundsException {
        for (int i = 0; i < x; i++) {
            for (int j = 0; j < y; j++) {
                if (i < tab.length && j < tab[i].length)
                    this.data[i][j] = tab[i][j];
            }
        }
    }

    public void matrixInitFromArray(double[] tab) throws IndexOutOfBoundsException {
        int id = 0;
        for (int i = 0; i < x; i++) {
            for (int j = 0; j < y; j++) {
                this.data[i][j] = tab[id];
                id++;
            }
        }
    }

    public void matrixRealloc(int x, int y) {
        double[][] tmp = this.data;
        this.x = x;
        this.y = y;
        this.data = new double[x][y];
        matrixFill(x, y, tmp);
    }

    public void matrixPrint(String s, int precision) {
        System.out.println(s + ": ");
        for (int i = 0; i < x; i++) {
            for (int j = 0; j < y; j++) {
                System.out.format("%8.2f", this.data[i][j]);
            }
            System.out.println();
        }
    }

    public void printTabAux(String s, int nbX, int nbZ, int nbAux) {
        System.out.println("---------------------------");
        System.out.println(s);
        System.out.println("---------------------------");
        System.out.print("COLS:              ");
        for (int i = 0; i < nbX; i++) {
            System.out.format("X[%d]      ", i);
        }

        for (int i = 0; i < nbZ; i++) {
            if (i < 10)
                System.out.format("Z[%d]      ", i);
            else
                System.out.format("Z[%d]     ", i);
        }

        System.out.format("S[%d]     ", this.y / 2);

        for (int i = 0; i < nbAux; i++) {
            if (i < 10)
                System.out.format("A[%d]      ", i);
            else
                System.out.format("A[%d]     ", i);
        }
        System.out.println();

        for (int i = 0; i < this.x; i++) {
            if (i < this.x - 2)
                if (i < 10)
                    System.out.print("AUX_" + i + "     |   ");
                else
                    System.out.print("AUX_" + i + "    |   ");
            else if (i == this.x - 2)
                System.out.print("OBJ. Init |   ");
            else System.out.print("OBJ.      |   ");
            for (int j = 0; j < this.y; j++) {
                System.out.format("%10.3f", this.data[i][j]);
            }
            System.out.println();
        }
    }
}
